【SPOJ】694. Distinct Substrings

http://www.spoj.com/problems/DISUBSTR/

题意:求字符串不同子串的数目。

#include <bits/stdc++.h>
using namespace std;

const int N=1005;
void sort(int *x, int *y, int *sa, int n, int m) {
	static int c[N], i;
	for(i=0; i<m; ++i) c[i]=0;
	for(i=0; i<n; ++i) ++c[x[y[i]]];
	for(i=1; i<m; ++i) c[i]+=c[i-1];
	for(i=n-1; i>=0; --i) sa[--c[x[y[i]]]]=y[i];
}
void hz(int *a, int *sa, int n, int m) {
	static int t1[N], t2[N], i, j, p, *x, *y, *t;
	x=t1, y=t2;
	for(i=0; i<n; ++i) x[i]=a[i], y[i]=i;
	sort(x, y, sa, n, m);
	for(j=1, p=1; p<n; j<<=1, m=p) {
		p=0;
		for(i=n-j; i<n; ++i) y[p++]=i;
		for(i=0; i<n; ++i) if(sa[i]-j>=0) y[p++]=sa[i]-j;
		sort(x, y, sa, n, m);
		for(t=x, x=y, y=t, p=1, x[sa[0]]=0, i=1; i<n; ++i)
			x[sa[i]]=y[sa[i]]==y[sa[i-1]]&&y[sa[i]+j]==y[sa[i-1]+j]?p-1:p++;
	}
}
void geth(int *s, int *sa, int *h, int n) {
	static int rank[N], j, i, k;
	for(i=1; i<=n; ++i) rank[sa[i]]=i;
	for(k=0, i=1; i<=n; h[rank[i++]]=k)
		for(k?--k:0, j=sa[rank[i]-1]; s[i+k]==s[j+k]; ++k);
}

int a[N], sa[N], h[N], n;
char s[N];
int main() {
	int cs;
	scanf("%d", &cs);
	while(cs--) {
		scanf("%s", s+1);
		n=strlen(s+1);
		for(int i=1; i<=n; ++i) a[i]=s[i];
		hz(a, sa, n+1, 128);
		geth(a, sa, h, n);
		int ans=0;
		for(int i=1; i<=n; ++i) ans+=n-sa[i]+1-h[i];
		printf("%d\n", ans);
	}
	return 0;
}

  



经典题....首先每个后缀的前缀就是一个子串,因此每个后缀可以构成这个后缀长度大小那么多个子串。但是我们要考虑重合的情况,即我们剪掉与上一个后缀子串相同前缀的height值就好啦

时间: 2024-10-11 15:02:15

【SPOJ】694. Distinct Substrings的相关文章

SPOJ 题目694 Distinct Substrings(后缀数组,求不同的子串个数)

DISUBSTR - Distinct Substrings no tags Given a string, we need to find the total number of its distinct substrings. Input T- number of test cases. T<=20; Each test case consists of one string, whose length is <= 1000 Output For each test case output

【SPOJ】Distinct Substrings(后缀自动机)

[SPOJ]Distinct Substrings(后缀自动机) 题面 Vjudge 题意:求一个串的不同子串的数量 题解 对于这个串构建后缀自动机之后 我们知道每个串出现的次数就是\(right/endpos\)集合的大小 但是实际上我们没有任何必要减去不合法的数量 我们只需要累加每个节点表示的合法子串的数量即可 这个值等于\(longest-shortest+1=longest-parent.longest\) #include<iostream> #include<cstdio&g

【SPOJ】Longest Common Substring II (后缀自动机)

[SPOJ]Longest Common Substring II (后缀自动机) 题面 Vjudge 题意:求若干个串的最长公共子串 题解 对于某一个串构建\(SAM\) 每个串依次进行匹配 同时记录\(f[i]\)表示走到了\(i\)节点 能够匹配上的最长公共子串的长度 当然,每个串的\(f[i]\)可以更新\(f[i.parent]\) 所以需要拓扑排序 对于每个串求出每个节点的最长匹配 然后对他们取\(min\),表示某个节点大家都能匹配的最长长度 最后对于所有点的值都取个\(max\)

【SPOJ】Longest Common Substring(后缀自动机)

[SPOJ]Longest Common Substring(后缀自动机) 题面 Vjudge 题意:求两个串的最长公共子串 题解 \(SA\)的做法很简单 不再赘述 对于一个串构建\(SAM\) 另外一个串在\(SAM\)上不断匹配 最后计算答案就好了 匹配方法: 如果\(trans(s,c)\)存在 直接沿着\(trans\)走就行,同时\(cnt++\) 否则沿着\(parent\)往上跳 如果存在\(trans(now,c),cnt=now.longest+1\) 否则,如果不存在可行的

【SPOJ】NUMOFPAL - Number of Palindromes(Manacher,回文树)

[SPOJ]NUMOFPAL - Number of Palindromes(Manacher,回文树) 题面 洛谷 求一个串中包含几个回文串 题解 Manacher傻逼题 只是用回文树写写而已.. #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<algorithm> #include<

【SPOJ】QTREE6(Link-Cut-Tree)

[SPOJ]QTREE6(Link-Cut-Tree) 题面 Vjudge 题解 很神奇的一道题目 我们发现点有黑白两种,又是动态加边/删边 不难想到\(LCT\) 最爆力的做法,显然是每次修改单点颜色的时候 暴力修改当前点和它的父亲以及儿子之间的连边状态 但是这样显然是假的(菊花树了解一下) 怎么优化呢? 对于每次操作,我们考虑如何只修改一次. 对于树上的一个结点,如果只修改一次,显然是修改和其父亲的状态. 那么,我们在考虑\(LCT\)的连边操作的时候, 如果当前点变色,那么就只修改和它父亲

【SPOJ】QTREE7(Link-Cut Tree)

[SPOJ]QTREE7(Link-Cut Tree) 题面 洛谷 Vjudge 题解 和QTREE6的本质是一样的:维护同色联通块 那么,QTREE6同理,对于两种颜色分别维护一棵\(LCT\) 每次只修改和它父亲的连边. 考虑如何维护最大值 因为每次\(access\)会删去一个数,所以我们肯定不能够只维护最大值. 因此,对于每一个节点,额外维护一个\(multiset\)(当然,可删堆,\(map\)之类的也行) 每次用\(multiset\)维护虚子树的最值,拿过去更新即可. 最后的答案

【SPOJ】Longest Common Substring

[SPOJ]Longest Common Substring 求两个字符串的最长公共子串 对一个串建好后缀自动机然后暴力跑一下 废话 讲一下怎么跑吧 从第一个字符开始遍历,遍历不到了再沿着\(parents\)走看能否找到出路,走到某个点时,统计一下走过了多少点然后更新答案 来说说这样做的正确性: 遍历是肯定的, PAM 从根节点出发的任意路径都表示一个子串 沿着\(parents\)边往后走,保证贪心情况下维护最长公共子串寻找出路 注意这里是统计走过了多少点更新答案,不能直接通过\(len\)

【SPOJ】Longest Common Substring II

[SPOJ]Longest Common Substring II 多个字符串求最长公共子串 还是将一个子串建SAM,其他字符串全部跑一边,记录每个点的最大贡献 由于是所有串,要对每个点每个字符串跑完后去最小值才是每个点的最终贡献 #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<algorithm